(function($) {
	
	jQuery(document).ready(function() {
		
		//--------------------------------------------
		// info tooltip
		//--------------------------------------------
			
		var hp_info;
		var btnClicked = '';
		
		$('.hp_info_btn').click(function(e) {
			e.preventDefault();
			
			if (btnClicked == $(this).attr('id')) {
				$('.hp_info').hide();
				btnClicked = '';
				return false;
			}
			
			btnClicked = $(this).attr('id');
			
			$('.hp_info').hide();
			hp_info = $(this).next('.hp_info');
			hp_info.show();
			hp_info.css( { top: $(this).position().top - 10, left: $(this).position().left } );
		});
		
		
		//--------------------------------------------
		// change event - open content
		//--------------------------------------------
		
		if ($('#_hp_open_content').val() == 'open_page') {
			$('#field_open_in_new_window').show();
			$('#field_lightbox_size').hide();
			$('#field_custom_link_url').hide();
		} else if ($('#_hp_open_content').val() == 'open_lightbox') {
			$('#field_open_in_new_window').hide();
			$('#field_lightbox_size').show();
			$('#field_custom_link_url').hide();
		} else if ($('#_hp_open_content').val() == 'custom_link') {
			$('#field_open_in_new_window').show();
			$('#field_lightbox_size').hide();
			$('#field_custom_link_url').show();
		}
		
		$('#_hp_open_content').change(function(e) {		
			if ($(this).val() == 'open_page') {
				$('#field_open_in_new_window').show();
				$('#field_lightbox_size').hide();
				$('#field_custom_link_url').hide();
			} else if ($(this).val() == 'open_lightbox') {
				$('#field_open_in_new_window').hide();
				$('#field_lightbox_size').show();
				$('#field_custom_link_url').hide();
			} else if ($(this).val() == 'custom_link') {
				$('#field_open_in_new_window').show();
				$('#field_lightbox_size').hide();
				$('#field_custom_link_url').show();
			}
		});
		
		
		//--------------------------------------------
		// change event - video url
		//--------------------------------------------
		
		if ($('#_hp_video_url').val() != '') {
			$('#field_video_type').show();
		} else {
			$('#field_video_type').hide();
		}
		
		$('#_hp_video_url').keyup(function(e) {	
				
			var str = $(this).val();
	
			if( $.trim(str) != '') {
				$('#field_video_type').show();
			} else {
				$('#field_video_type').hide();
			}
		});
		
		
		//--------------------------------------------
		// change event - add excerpt
		//--------------------------------------------
		
		if ($('#hpAddExcerpt').val() == 'true') {
			$('#field_hpExcerptNumWords').show();
		} else {
			$('#field_hpExcerptNumWords').hide();
		}
		
		$('#hpAddExcerpt').change(function(e) {		
			if ($(this).val() == 'true') {
				$('#field_hpExcerptNumWords').show();
			} else {
				$('#field_hpExcerptNumWords').hide();
			}
		});
		
		
		//--------------------------------------------
		// change event - custom skin
		//--------------------------------------------
		
		if ($('#hpSkin').val() == 'custom') {
			$('#hpCustomSkinContainer').show();
		} else {
			$('#hpCustomSkinContainer').hide();
		}
		
		$('#hpSkin').change(function(e) {		
			if ($(this).val() == 'custom') {
				$('#hpCustomSkinContainer').show();
			} else {
				$('#hpCustomSkinContainer').hide();
			}
		});
		
		
		
		//--------------------------------------------
		// custom post type / taxonomy
		//--------------------------------------------
		
		if ( $('#hp_url').val() != undefined ) {
		
			var data = {
				action: 'hp_taxonomy_ajax',
				post_type: $('#hpPostType').val(),
				id: $('#hp_id').val()
			};
			
			$.get(hopos_util.ajaxurl, data, function(data) {
				$('#field_tax_categories').html( data );
			});

		}
		
		
		$('#hpPostType').change(function(e) {
	
			var data = {
				action: 'hp_taxonomy_ajax',
				post_type: $(this).val(),
				id: $('#hp_id').val()
			};
			
			$.get(hopos_util.ajaxurl, data, function(data) {
				$('#field_tax_categories').html( data );
	
			});
		});
		
		
		//--------------------------------------------
		// save options ajax
		//--------------------------------------------
		
		$('#save_hopos').click(function(e) {
			e.preventDefault();
			
			$('.hpPreload').css({display:'block'});
			$('.hpSaved').css({display:'none'});
			
			var cats = '';
			
			$('#field_tax_categories input').each(function() {				
				if ( $(this).is(':checked') ) {
					cats += $(this).val() + ",";
				}
			});
			
			var n = cats.lastIndexOf(",");
			cats = cats.substr(0,n);
			
			//alert( $('#hp_id').val() ); return false;
			//alert( $('#hpCustomSkin').val() ); return false;
			
				
			var data = {
				action: 'hp_save_ajax',	
				hp_action: $('#hp_action').val(),
				hp_id: $('#hp_id').val(),
				hp_name: $('#title').val(),
				hpCustomSkin: $('#hpCustomSkin').val(),
				
				hpPostsPerSlide: $('#hpPostsPerSlide').val(),
				hpSlideWidth: $('#hpSlideWidth').val(),
				hpPostMargin: $('#hpPostMargin').val(),
				hpShowPreviousNext: $('#hpShowPreviousNext').val(),
				hpScrollSpeed: $('#hpScrollSpeed').val(),
				hpAutoSlide: $('#hpAutoSlide').val(),
				hpAutoSlideDelay: $('#hpAutoSlideDelay').val(),
				hpShowPlayPause: $('#hpShowPlayPause').val(),
				hpShowPagination: $('#hpShowPagination').val(),
				hpAlignPagination: $('#hpAlignPagination').val(),
				hpSwipeDrag: $('#hpSwipeDrag').val(),
				hpPageStyle: $('#hpPageStyle').val(),
				hpOrientation: $('#hpOrientation').val(),
				hpThumbWidth: $('#hpThumbWidth').val(),
				hpThumbHeight: $('#hpThumbHeight').val(),
				hpSkin: $('#hpSkin').val(),
				hpAddExcerpt: $('#hpAddExcerpt').val(),
				hpExcerptNumWords: $('#hpExcerptNumWords').val(),
				hpAddShadow: $('#hpAddShadow').val(),
				hpTitleHeader: $('#hpTitleHeader').val(),
				hpAmountPosts: $('#hpAmountPosts').val(),
				hpCategories: cats,
				hpPostType: $('#hpPostType').val(),
				hpTaxonomy: $('#hpTaxonomy').val(),
				hpOrderby: $('#hpOrderby').val(),
				hpOrder: $('#hpOrder').val()
			};
				
			$.post(hopos_util.ajaxurl, data).error( 
				function() {
					alert('Error. Please try again.');
				}).success( function(data) {
					
					//alert(data); return false;
					
					if (data == 'permission denied') {
						alert ('permission denied');
						return false;
					}

					if (data == 'saved') {
						
						//edit //message
						$('.hpPreload').css({display:'none'});
						$('.hpSaved').css({display:'block', opacity:0}).stop().animate({ opacity:1 }, { duration: 400 });
						setTimeout( function() { $('.hpSaved').stop().animate({ opacity:0 }, { duration: 600 }) }, 4000);
					
					} else {

						//add
						var splitData = data.split("||");
						var hp_url = $('#hp_url').val() + '&action=edit&id=' + splitData[1];
						window.location = hp_url;
					}
				});

			return false;
	
		});//save
		
		
		//--------------------------------------------
		// delete item
		//--------------------------------------------
		
		$('.delete_hopos').click(function(e) {
			
			e.preventDefault();
			
			var name = $(this).attr('data-name');
			var conf = confirm('Confirm delete? \n"' + name + '"');
			
			if (conf == true) {
				
				var id = $(this).attr('id').split("_");
				
				var data = {
					action: 'hp_delete_ajax',
					hp_action: 'delete',
					hp_id: id[1]
				}
				
				$.post(hopos_util.ajaxurl, data).error( 
					function() {
						alert('Error. Please try again.');
					}).success( function(data) {
						
						if (data == 'permission denied') {
							alert ('permission denied');
							return false;
						}	
						
						if (data == 'deleted') {
							var hp_url = $('#hp_url_list').val() + '&action=list';
							window.location = hp_url;
						}
					});
			}
		
		});//delete
		
		
		//--------------------------------------------
		// title prompt
		//--------------------------------------------
			
		$('#titlediv #title').click(function(e) {
			$('#hp-title-prompt-text').hide();
		});
		
	});//ready

})(jQuery);